<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/ring_zero_peek_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>02/13/84  ring_zero_peek_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>The ring_zero_peek_ subroutine is used to copy information out of an
<span id="L4" class="LineNr">  4 </span>inner ring segment.  The user must have access to either the phcs_ gate
<span id="L5" class="LineNr">  5 </span>or the metering_ring_zero_peek_ gate in order to use any of the entry
<span id="L6" class="LineNr">  6 </span>points in this subroutine.  The phcs_ gate allows unrestricted access
<span id="L7" class="LineNr">  7 </span>to all inner ring segments; metering_ring_zero_peek_ allows the user to
<span id="L8" class="LineNr">  8 </span>examine specifically those data bases that are useful for metering the
<span id="L9" class="LineNr">  9 </span>system.  The program chooses the appropriate gate depending on the
<span id="L10" class="LineNr"> 10 </span>user's access and the segments being examined.
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>Entry points in ring_zero_peek_:
<span id="L14" class="LineNr"> 14 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>:Entry: ring_zero_peek_: 02/13/84 ring_zero_peek_
<span id="L18" class="LineNr"> 18 </span>
<span id="L19" class="LineNr"> 19 </span>Function: copies information out of a segment in the Multics
<span id="L20" class="LineNr"> 20 </span>supervisor, given a pointer to it.
<span id="L21" class="LineNr"> 21 </span>
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>Syntax:
<span id="L24" class="LineNr"> 24 </span>declare ring_zero_peek_ entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>19<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L25" class="LineNr"> 25 </span>call ring_zero_peek_ <span class="textRainbow_lv0_p0">(</span>ptr0<span class="textRainbow_lv0_o0">,</span> ptr_user<span class="textRainbow_lv0_o0">,</span> nwords<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>Arguments:
<span id="L29" class="LineNr"> 29 </span>ptr0
<span id="L30" class="LineNr"> 30 </span>   is a pointer to the data in ring 0 that is to be copied out.
<span id="L31" class="LineNr"> 31 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L32" class="LineNr"> 32 </span>ptr_user
<span id="L33" class="LineNr"> 33 </span>   is a pointer to the region in the user's address space where the
<span id="L34" class="LineNr"> 34 </span>   data is to be copied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L35" class="LineNr"> 35 </span>nwords
<span id="L36" class="LineNr"> 36 </span>   is the number of words to be copied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L37" class="LineNr"> 37 </span>code
<span id="L38" class="LineNr"> 38 </span>   is the standard status code that is nonzero if the user did not have
<span id="L39" class="LineNr"> 39 </span>   access to the requested data.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span>
<span id="L42" class="LineNr"> 42 </span>:Entry:  by_definition:  02/13/84 ring_zero_peek_$by_definition
<span id="L43" class="LineNr"> 43 </span>
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>Function: copies information out of a named segment in the Multics
<span id="L46" class="LineNr"> 46 </span>supervisor, starting at a named symbol.  It is like
<span id="L47" class="LineNr"> 47 </span>ring_zero_peek_$by_name, except that the copying is done from the
<span id="L48" class="LineNr"> 48 </span>specified definition, rather than from the base of the segment.
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>Syntax:
<span id="L52" class="LineNr"> 52 </span>declare ring_zero_peek_$by_definition entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L53" class="LineNr"> 53 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>18<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> pointer<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>19<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L54" class="LineNr"> 54 </span>call ring_zero_peek_$by_definition <span class="textRainbow_lv0_p0">(</span>segment_name<span class="textRainbow_lv0_o0">,</span> symbol_name<span class="textRainbow_lv0_o0">,</span> offset<span class="textRainbow_lv0_o0">,</span>
<span id="L55" class="LineNr"> 55 </span>     ptr_user<span class="textRainbow_lv0_o0">,</span> word_count<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L56" class="LineNr"> 56 </span>
<span id="L57" class="LineNr"> 57 </span>
<span id="L58" class="LineNr"> 58 </span>Arguments:
<span id="L59" class="LineNr"> 59 </span>segment_name
<span id="L60" class="LineNr"> 60 </span>   is the name of the supervisor segment from which words are to be
<span id="L61" class="LineNr"> 61 </span>   copied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  It cannot be a pathname.
<span id="L62" class="LineNr"> 62 </span>symbol_name
<span id="L63" class="LineNr"> 63 </span>   is the name of the external symbol in the specified segment at which
<span id="L64" class="LineNr"> 64 </span>   copying is to start.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L65" class="LineNr"> 65 </span>offset
<span id="L66" class="LineNr"> 66 </span>   is the offset from the specified definition at which copying is to
<span id="L67" class="LineNr"> 67 </span>   start.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  It can be specified as zero to cause copying to
<span id="L68" class="LineNr"> 68 </span>   start at the specified definition.
<span id="L69" class="LineNr"> 69 </span>
<span id="L70" class="LineNr"> 70 </span>
<span id="L71" class="LineNr"> 71 </span>ptr_user
<span id="L72" class="LineNr"> 72 </span>   is a pointer to the area in the outer ring where the data is to be
<span id="L73" class="LineNr"> 73 </span>   copied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L74" class="LineNr"> 74 </span>word_count
<span id="L75" class="LineNr"> 75 </span>   is the number of words to be copied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L76" class="LineNr"> 76 </span>code
<span id="L77" class="LineNr"> 77 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  It is nonzero if the segment
<span id="L78" class="LineNr"> 78 </span>   cannot be found, if the specified external symbol does not exist or
<span id="L79" class="LineNr"> 79 </span>   is ambiguous, or if the user does not have sufficient access to copy
<span id="L80" class="LineNr"> 80 </span>   the requested data.
<span id="L81" class="LineNr"> 81 </span>
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>Notes:  This entry point can be used to avoid a call to ring0_get_.
<span id="L84" class="LineNr"> 84 </span>For examining segments in the supervisor, this entry point and the
<span id="L85" class="LineNr"> 85 </span>by_name entry point are recommended because they are much simpler
<span id="L86" class="LineNr"> 86 </span>to use than ring0_get_, and they are only minimally less efficient.
<span id="L87" class="LineNr"> 87 </span>Generally, it is nearly as efficient to use this entry point as it is
<span id="L88" class="LineNr"> 88 </span>to save static pointers to inner ring objects.
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>:Entry:  by_name:  02/13/84 ring_zero_peek_$by_name
<span id="L92" class="LineNr"> 92 </span>
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>Function: copies information out of a named segment in the Multics
<span id="L95" class="LineNr"> 95 </span>supervisor.  It is like ring_zero_peek_, except that the name of the
<span id="L96" class="LineNr"> 96 </span>ring zero segment is provided, rather than a pointer to it.
<span id="L97" class="LineNr"> 97 </span>
<span id="L98" class="LineNr"> 98 </span>
<span id="L99" class="LineNr"> 99 </span>Syntax:
<span id="L100" class="LineNr">100 </span>declare ring_zero_peek_$by_name entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>18<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> pointer<span class="textRainbow_lv0_o0">,</span>
<span id="L101" class="LineNr">101 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>19<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L102" class="LineNr">102 </span>call ring_zero_peek_$by_name <span class="textRainbow_lv0_p0">(</span>segment_name<span class="textRainbow_lv0_o0">,</span> offset<span class="textRainbow_lv0_o0">,</span> copy_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L103" class="LineNr">103 </span>     word_count<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L104" class="LineNr">104 </span>
<span id="L105" class="LineNr">105 </span>
<span id="L106" class="LineNr">106 </span>Arguments:
<span id="L107" class="LineNr">107 </span>segment_name
<span id="L108" class="LineNr">108 </span>   is the name of the supervisor segment from which data is to be
<span id="L109" class="LineNr">109 </span>   copied.  It cannot be a pathname.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L110" class="LineNr">110 </span>offset
<span id="L111" class="LineNr">111 </span>   is the offset from the beginning of the segment at which copying is
<span id="L112" class="LineNr">112 </span>   to start.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  It can be specified as zero to cause copying to
<span id="L113" class="LineNr">113 </span>   start from the base of the segment.
<span id="L114" class="LineNr">114 </span>copy_ptr
<span id="L115" class="LineNr">115 </span>   is a pointer to the area in the outer ring where the data is to be
<span id="L116" class="LineNr">116 </span>   copied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L117" class="LineNr">117 </span>
<span id="L118" class="LineNr">118 </span>
<span id="L119" class="LineNr">119 </span>word_count
<span id="L120" class="LineNr">120 </span>   is the number of words to be copied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L121" class="LineNr">121 </span>code
<span id="L122" class="LineNr">122 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  It is nonzero if the segment
<span id="L123" class="LineNr">123 </span>   cannot be found, or if the user does not have sufficient access to
<span id="L124" class="LineNr">124 </span>   copy the requested data from it.
<span id="L125" class="LineNr">125 </span>
<span id="L126" class="LineNr">126 </span>
<span id="L127" class="LineNr">127 </span>Notes:  This entry point can be used to avoid a call to ring0_get_.
<span id="L128" class="LineNr">128 </span>For examining segments in the supervisor, this entry point and the
<span id="L129" class="LineNr">129 </span>by_definition entry point are recommended because they are much simpler
<span id="L130" class="LineNr">130 </span>to use than ring0_get_, and they are only minimally less efficient.
<span id="L131" class="LineNr">131 </span>Generally, it is nearly as efficient to use this entry point as it is
<span id="L132" class="LineNr">132 </span>to save static pointers to inner ring objects.
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>:Entry:  get_max_length:  02/13/84 ring_zero_peek_$get_max_length
<span id="L136" class="LineNr">136 </span>
<span id="L137" class="LineNr">137 </span>
<span id="L138" class="LineNr">138 </span>Function: determines the maximum length of a named ring zero segment.
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>Syntax:
<span id="L142" class="LineNr">142 </span>declare ring_zero_peek_$get_max_length entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>19<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L143" class="LineNr">143 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L144" class="LineNr">144 </span>call ring_zero_peek_$get_max_length <span class="textRainbow_lv0_p0">(</span>seg_name<span class="textRainbow_lv0_o0">,</span> max_length<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>
<span id="L147" class="LineNr">147 </span>Arguments:
<span id="L148" class="LineNr">148 </span>seg_name
<span id="L149" class="LineNr">149 </span>   is the name of the ring zero segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L150" class="LineNr">150 </span>max_length
<span id="L151" class="LineNr">151 </span>   is the maximum length <span class="textRainbow_lv0_p0">(</span>in words<span class="textRainbow_lv0_p0">)</span> of the segment.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L152" class="LineNr">152 </span>code
<span id="L153" class="LineNr">153 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  It is nonzero if the user
<span id="L154" class="LineNr">154 </span>   does not have sufficient access to copy the requested data, or if
<span id="L155" class="LineNr">155 </span>   the segment does not exist.
<span id="L156" class="LineNr">156 </span>
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>:Entry:  get_max_length_ptr:
<span id="L159" class="LineNr">159 </span>02/13/84 ring_zero_peek_$get_max_length_ptr
<span id="L160" class="LineNr">160 </span>
<span id="L161" class="LineNr">161 </span>
<span id="L162" class="LineNr">162 </span>Function: determines the maximum length of a specified segment by
<span id="L163" class="LineNr">163 </span>examining its SDW.  The user must have sufficient access to examine
<span id="L164" class="LineNr">164 </span>the SDW for the segment.
<span id="L165" class="LineNr">165 </span>
<span id="L166" class="LineNr">166 </span>
<span id="L167" class="LineNr">167 </span>Syntax:
<span id="L168" class="LineNr">168 </span>declare ring_zero_peek_$get_max_length_ptr entry <span class="textRainbow_lv0_p0">(</span>pointer<span class="textRainbow_lv0_o0">,</span>
<span id="L169" class="LineNr">169 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>19<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L170" class="LineNr">170 </span>call ring_zero_peek_$get_max_length_ptr <span class="textRainbow_lv0_p0">(</span>seg_ptr<span class="textRainbow_lv0_o0">,</span> max_length<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>
<span id="L173" class="LineNr">173 </span>Arguments:
<span id="L174" class="LineNr">174 </span>seg_ptr
<span id="L175" class="LineNr">175 </span>   is a pointer to the segment for which the max length is to be
<span id="L176" class="LineNr">176 </span>   returned.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  If the segment is not active at the time of the
<span id="L177" class="LineNr">177 </span>   call, the user must have sufficient access to reference the segment,
<span id="L178" class="LineNr">178 </span>   and this reference causes a segment fault.
<span id="L179" class="LineNr">179 </span>max_length
<span id="L180" class="LineNr">180 </span>   is the maximum length <span class="textRainbow_lv0_p0">(</span>in words<span class="textRainbow_lv0_p0">)</span> of the segment.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L181" class="LineNr">181 </span>code
<span id="L182" class="LineNr">182 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  It is nonzero if the user
<span id="L183" class="LineNr">183 </span>   does not have sufficient access to copy the requested data, or if
<span id="L184" class="LineNr">184 </span>   the segment does not exist.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
